<template>
  <div>
    <su-service :icon="'lightbulb-o'">
      <template #title>
        Les initiatives
      </template>
      <p>
        L'ensemble des initiatives à valider sont listées dans le tableau suivant.
      </p>
    </su-service>
    <br />
    <b-table
      :data="allInitiatives"
      :striped="true"
      :hoverable="true"
      :sort-icon="'angle-up'"
      paginated
      per-page="50"
      default-sort="valid"
    >
      <b-table-column field= "valid" sortable label="Validité" centered v-slot="props">
        <b-tag rounded v-if="props.row.valid" type="is-success">Validé</b-tag>
        <b-tag rounded v-else type="is-danger">Non validé</b-tag>
      </b-table-column>
      <b-table-column field= "laboratory.name" sortable label="Laboratoire" centered v-slot="props">
        {{ props.row.laboratory.name }}
      </b-table-column>
      <b-table-column field= "laboratory.mainSite" sortable label="Ville" centered v-slot="props">
        {{ props.row.laboratory.mainSite }}
      </b-table-column>
      <b-table-column field= "laboratory.administrations" sortable label="Tutelle(s)" centered v-slot="props">
        {{ props.row.laboratory.administrations.map(obj => obj.name).join(', ') }}
      </b-table-column>
      <b-table-column field= "referent.email" sortable label="Référant" centered v-slot="props">
        {{ props.row.laboratory.referent.email }}
      </b-table-column>
      <b-table-column field= "description" sortable label="Description" centered v-slot="props">
        {{ props.row.description }}
      </b-table-column>
      <b-table-column centered v-slot="props">
        <div class="panel-block">
          <b-button
            size="is-small"
            @click="displayInitiative(props.row)"
          >
            <i class="sui sui-eye" style="font-size: 16px;"></i>
          </b-button>
          <b-button
            size="is-small"
            @click="validateInitiative(props.row)"
          >
            <i class="sui sui-check" style="font-size: 16px;"></i>
          </b-button>
        </div>
      </b-table-column>
      <section slot="empty" class="section">
        <div class="content has-text-grey has-text-centered">
          <p>
            <i class="sui sui-ban" style="font-size: 64px;"></i>
          </p>
          <p>Aucune initiative</p>
        </div>
      </section>
    </b-table>
    <b-modal
      :active.sync="displayModal"
      has-modal-card
      style="z-index:9999"
    >
      <div class="modal-card" style="width: 1000px; height: auto;z-index:9999">
        <section class="modal-card-body">
          <vue-initiative :initiative="cinitiative"/>
        </section>
      </div>
    </b-modal>
  </div>
</template>

<script>
import SUService from '@/components/SUService.vue'
import { mapGetters } from 'vuex'

export default {
  name: 'GES1point5Admin',
  components: {
    'su-service': SUService,
    'vue-initiative': () => import('@/components/transition/VueInitiative.vue')
  },
  data () {
    return {
      cinitiative: null,
      displayModal: false
    }
  },
  computed: {
    ...mapGetters('authentication', ['isAuthenticated']),
    allInitiatives: function () {
      return this.$store.getters['superadmin/allInitiatives']
    }
  },
  methods: {
    displayInitiative (initiative) {
      this.cinitiative = initiative
      this.displayModal = true
    },
    validateInitiative (initiative) {
      let self = this
      this.$buefy.dialog.confirm({
        title: 'Publication',
        message: 'Êtes vous sûr de vouloir publier cette initiative ?',
        confirmText: 'Valider',
        cancelText: 'Annuler',
        canCancel: ['escape', 'button', 'outside'],
        onConfirm: function () {
          const loadingComponent = self.$buefy.loading.open({
            container: null
          })
          self.$store.dispatch('superadmin/valdidateInitiative', initiative)
            .then(data => {
              loadingComponent.close()
            })
        }
      })
    }
  },
  mounted () {
    if (this.isAuthenticated) {
      const loadingComponent = this.$buefy.loading.open({
        container: null
      })
      this.$store.dispatch('superadmin/getAllInitiatives')
        .then(data => {
          loadingComponent.close()
        })
    }
  }
}
</script>
